
    #version 310 es
    #pragma only_renderers glsl31 metal
    // keywords
    #pragma multi_compile VFX_COMPAT_MODE
    #pragma input cs_in
    #pragma end

    #pragma output cs_out
    #pragma end

    #pragma cs cs_in cs_out
    #define BUFFER_WIDTH 2048

    struct BuiltinParameters
    {
    float delta;
    uint dispatchWidth;
    uint nbSpawned;
    uint spawnId;
    uint systemSeed;
    };


    layout(binding = 0, std140) uniform builtiParameters
    {
    BuiltinParameters builtiParametersValue;
    };

    layout(std430, binding = 0) buffer attributeBuffer {
    uint attributeBuffer_buf[];
    };

    layout(std430, binding = 1) buffer sortBuffer {
    uint sortBuffer_buf[];
    };

    precision highp float;

    #ifdef VFX_COMPAT_MODE
    layout(r32f, binding = 0) uniform highp image2D attributeBuffer_vs;
    layout(r32f, binding = 1) uniform highp image2D sortBuffer_vs;

    #define WRITE_BUFFER(buf, index, data) imageStore(buf, ivec2((index) % BUFFER_WIDTH, (index) / BUFFER_WIDTH), vec4(data))
    #endif
    //use thread_group_size = 64
    layout(local_size_x = 64, local_size_y = 1, local_size_z = 1) in;
    #pragma end
    void compute()
    {
    #ifdef VFX_COMPAT_MODE
    uint particleIdx = gl_GlobalInvocationID.x;

    int index_c = int(particleIdx << 6u);
    for(int i = 0; i < 64; i++)
    {
        WRITE_BUFFER(attributeBuffer_vs, index_c + i, uintBitsToFloat(attributeBuffer_buf[index_c + i]));
    }

    if(particleIdx < builtiParametersValue.nbSpawned)
    {
        WRITE_BUFFER(sortBuffer_vs, int(particleIdx), uintBitsToFloat(sortBuffer_buf[particleIdx]));
    }
    #endif
    return;
    }
    